*-- Author :    Hartwig Albrecht   23/03/93

      SUBROUTINE IOINIT

************************************************************************
*
* Description: Default logical units
*
* Called from: ATINIT
*
* External references: /ZUNIT/ Zebra units
*
* Arguments: none
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/MEIO.fi"
#include "arte/ArteFlag.fi"
#include "arte/ZIOCOM.fi"

      INTEGER K

#include "arte/Arte.ff"
#include "auto/MEIO.ff"

      DO K = 1, 99
        CALL CHCTOH (' ', IQ(HQMEIO_NAME(1,K)), 30)
        CALL CHCTOH (' ', IQ(HQMEIO_ZOPTION(1,K)), 2)
        IQ(IQMEIO_IOSTAT(K)) = -1
        IQ(IQMEIO_FLAG(K)) = -1
        IQ(IQMEIO_RLENG(K)) = -1
        IQ(IQMEIO_FORMAT(K)) = -1
      END DO

      DO K = 1, 99
        CALL CHCTOH (' ', IQ(HQMEIO_STREAM(1,K)), 20)
        IQ(IQMEIO_CURRENT(K)) = K
      END DO

      DO  K = 1, 4
        FIOMIX(K) = 0.
      END DO

      IF (NOPRINT .EQ. 0)  THEN
        IF (IBATCH .EQ. 0)  THEN
          LITRM = LSTDI
          LOTRM = LSTDO
          LPRNT = 4
        ELSE
          LITRM = 0
          LOTRM = 0
          LPRNT = LSTDO
        END IF
      ELSE
        LITRM = LSTDI
        LOTRM = LSTDO
        LPRNT = 0
      END IF

      CALL IODECL (LSTDI, 'STDI', '(standard input)')
      CALL IODECL (LSTDO, 'STDO', '(standard output)')

      IF (NOPRINT .EQ. 0)  THEN
        CALL IODECL (LLOGF, 'LOGF', ' ')
        C78 = JOBNAME
        CALL CH78AC ('.logf')
        CALL IOCONC (LLOGF, C78, 'O', 0)
        CALL IOOPEN (LLOGF, 'OF', 0, K)

        IF(IBATCH.EQ.0) THEN
          CALL IODECL (LPRNT, 'PRNT', ' ')
          C78 = JOBNAME
          CALL CH78AC ('.prnt')
          CALL IOCONC (LPRNT, C78, 'O', 0)
          CALL IOOPEN (LPRNT, 'OF', 0, K)
        ENDIF
      ENDIF

      LHIST = 1
      CALL IODECL (LHIST, 'HIST', '(histogram file)')

      DO K = 11, 15
        CALL IODECL (K, ' ', '(reserved for KUIP)')
      END DO

      LPRIS = 10
      CALL IODECL (LPRIS, 'PRISM', '(event display)')

      LDSTI = 21
      CALL IODECL (LDSTI, 'DST_IN_NOTE', '(DST input with Notebook)')

      LMINII = 22
      CALL IODECL (LMINII, 'MINI_IN_NOTE', '(MINI input with Notebook)')

      LDSTIE = 23
      CALL IODECL (LDSTIE, 'DST_IN_EDIR',
     +             '(DST input with Event Directory)')

      LMINIIE = 24
      CALL IODECL (LMINIIE, 'MINI_IN_EDIR',
     +             '(MINI input with Event Directory)')

      LNOTEI = 25
      CALL IODECL (LNOTEI, 'NOTE_IN', '(Notebook input)')

      LEDIRI = 26
      CALL IODECL (LEDIRI, 'EDIR_IN', '(Event Directory input)')

      LEVI = 30
      CALL IODECL (LEVI, 'EV_IN', '(general event input: DST or MINI)')

      LEVI1 = 31
      CALL IODECL (LEVI1, 'EVIN1', '(event input 1 for event mixing)')

      LEVI2 = 32
      CALL IODECL (LEVI2, 'EVIN2', '(event input 2 for event mixing)')

      LEVI3 = 33
      CALL IODECL (LEVI3, 'EVIN3', '(event input 3 for event mixing)')

      LEVI4 = 34
      CALL IODECL (LEVI4, 'EVIN4', '(event input 4 for event mixing)')

      LDSTO = 41
      CALL IODECL (LDSTO, 'DST_OUT', '(event output - DST)')

      LMINIO = 42
      CALL IODECL (LMINIO, 'MINI_OUT', '(event output - MINI)')

      LNOTEO = 43
      CALL IODECL (LNOTEO, 'NOTE_OUT', '(output - Notebook)')

      LGEDB = 50
      CALL IODECL (LGEDB, 'GEODB', '(geometry data base)')

      LGEOI = 51
      CALL IODECL (LGEOI, 'GEOMIN', '(geometry constants input)')

      LGEOO = 52
      CALL IODECL (LGEOO, 'GEOMOUT', '(geometry constants output)')

      LL1SI = 53
      CALL IODECL (Ll1SI, 'L1SIMU', '(trigger level 1)')

      LDDEF = 54
      CALL IODECL (LDDEF, 'DDEFINITION', '(Data Definition files)')

      LREAD = 61
      CALL IODECL (LREAD, 'READ', '(FFREAD)')

c Added by A.Lanyov,  Sep-1997
      LREAD1 = 62
      CALL IODECL (LREAD1, 'READ1', '(FFREAD for A.Lanyov)')

      LTAIN = 63
      CALL IODECL (LTAIN, 'TAIN', '(tracker c&a input)')

      LTAOUT = 64
      CALL IODECL (LTAOUT, 'TAOUT', '(tracker c&a output)')

      END

************************************************************************
* End of IOINIT
************************************************************************
