using namespace std;

#include<iostream.h>
#include<vector>
#include<algorithm>
//#include<numeric>
#include "arte/arte.hh"

#define sqr(x)  ((x)*(x))

//
// a class for averaging
//
class AverageInFilledPlanes {
private:
  int anz;   //Anzahl Elemente
  int sum;   //Summe der Werte
public:
  AverageInFilledPlanes():anz(0),sum(0) {}    //Konstruktor
  //Elemente aufnehemn
  void operator()(int elem) {
    if(elem > 0) {
      anz++;
      sum+=elem;
    }
  }
  //Mittelwert durch Verwendung als double liefern
  operator double() {
    return static_cast<double>(sum) / static_cast<double>(anz);
  }
};


extern "C" {

//
// EventFilter function
//
int EventFilter(void) {
  static  int ngedes = 0;
  static  bool firsttime = true;
  
  // Determine no of VDS planes
  if(firsttime){
    for (ArteTable<GEDE>::iterator gede = ArteTable<GEDE>::begin(); gede !=
	   ArteTable<GEDE>::end(); ++gede) {
      if (gede->cmp == 1)
	ngedes++;
    }
    cout << "-------> VDS::EventFilter: found " << ngedes << " VDS gede planes" << endl;
    firsttime = false;
  }
  
  vector<int> nhitSide(ngedes);
  vector<int> hashits(ngedes);
  
  unsigned int lastempty = 0;
  unsigned int nhits = 0;
  
  ArteTable<HITB>::iterator hitb_begin = ArteTable<HITB>::begin();
  ArteTable<HITB>::iterator hitb_end = ArteTable<HITB>::end();
  for (ArteTable<HITB>::iterator hitb = hitb_begin; hitb !=
	 hitb_end; ++hitb) {
    
    // select VDS hits
    if(hitb->gede->cmp != 1)
      continue;
    
    // count no of hits in VDS
    nhits++;
    
    //      cout << "gede index: " << hitb->gede.index()+1 << endl;
    int gede_idx = hitb->gede.index() - 1;
    nhitSide[gede_idx]++;
    if(hashits[gede_idx] == 0) hashits[gede_idx] = 1;
  }
  
  double average = for_each(nhitSide.begin(), nhitSide.end(),
			      AverageInFilledPlanes());
  
  // count how many empty planes exists at the end of hashits[]
  // if marvin buffer was full, there should be empty planes at the end
  for(int i=(ngedes-1); i>=0; i--){
    if(hashits[i]==0)
      lastempty++;
    else
      break;
  }
  
#ifdef XXX
  double sigma = 0, sigmasum=0;
  unsigned int full=0, hitsum=0;
  
  //compute hitsum
  hitsum = accumulate(nhitSide.begin(), nhitSide.end(), 0);
  //compute no of planes with hits
  full   = accumulate(hashits.begin(), hashits.end(), 0);
  
  // compute sigma
  for(int i=0; i<ngedes; i++) {
    if(nhitSide[i]>0)
      sigmasum += sqr(double(nhitSide[i])-average);
  }
  if(full>0)
    sigma = sqrt(sigmasum/(full-1));
  
  cout << "no of hits: " << hitsum << " planes with hits: " << full 
       << " average: " << average << " empty planes: " << ngedes-full
       << " sigma: " << sigma << " planes hit: " << full/double(ngedes)
       << " lastempty: " << lastempty
       << endl;
#endif
  
  // Cry if empty VDS event is found
  if(nhits == 0) {
    cout << "------------>"                          << endl;
    cout << "------------> Empty VDS event found!!!" << endl;
    cout << "------------>"                          << endl;
    return false;
  }
  
  // kill-condition
  if(lastempty > 2 && average > 6.5) {
    cout << "------------>"                       << endl;
    cout << "------------> Corrupted VDS EVENT!!" << endl;
    cout << "------------>"                       << endl;
    return false;
  } else {
    return true;
  }
} // EventFilter end
}
