//                              -*- Mode: C++ -*-
//:dgcal_enecalc.C
// 
//:description - ENERGY DEPOSITION CALCULATION IN EACH CELL
//
// Author: Benedetto Giacobbe   
// ECAL group 
// HERA-B experiment, Desy
// e-mail: giacobbe@bo.infn.it
//
// Created 26/7/97
// Last Update ........
//

#include "arte/arte.hh"
#include "care/dgcal.hh"

extern "C"
{
  float dgcal_enecalc(int ipl, int ix, int iy){
    
    ArtePointer<GCAL> gcal(ipl);
    int nmim = 0;
    float ener = 0.;
    if((gcal->mim1).index() != 0) nmim = (gcal->miml).index() -
	(gcal->mim1).index() + 1; //num MCAL in IPL
    if(nmim > 0){
      int ndim = gcal->ncl;
      for(int l = 0; l < nmim; l++){
	int il = (gcal->mim1).index() + l;
	ArtePointer<MCAL> mcal(il);
        int icmp = ((mcal->gcal)>>24);
	if( icmp==0 || ArtePointer<GESL>(icmp)->cmp==7){
	  if( ((mcal->gcal & 0x00FFFFFF) -ipl*100) ==
	ndim*ix+iy){
	    ener += mcal->de;
	  }
	}
      }
    } else {
      ener = 0.;
    }
    return ener;
  }  
}
