*-- Author :    Thomas Lohse       May 25, 1999
      SUBROUTINE KADGCU

************************************************************************
*
* Description: Cut selection for detector regions to be excluded
*              from digitization
*
* Called from: KUIP
*
* External references:
*
* Argument in/out description
*
************************************************************************

      IMPLICIT NONE

#include "digi/dgcut.fi"

      INTEGER NCOMP
      PARAMETER (NCOMP=9)
      character*3 COMP(NCOMP)
      data COMP / 'SVD','OTR','ITR','PTL',
     1                        'RIC','TRD','ECA','MUD','MXD' /
      save COMP

      integer L, I
      character*4 CH

      integer mes_id_1, mes_id_2, mes_id_3
      save mes_id_1, mes_id_2, mes_id_3
      integer init
      data init /0/
      save init

      if (init.eq.0) then
        init = 1
        NCUTDG = 0
      endif

      if (NCUTDG.eq.NCUTMX) then
        CALL MEERRC (mes_id_1,
     +   'DGCUT: Buffer Overflow!!! Too many cuts required!!!')
        goto 999
      endif

      NCUTDG = NCUTDG + 1

      CALL KUGETC (CH, L)
      DGCUCO(NCUTDG) = CH

      CALL KUGETR(XCUMIN(NCUTDG))
      CALL KUGETR(XCUMAX(NCUTDG))
      CALL KUGETR(YCUMIN(NCUTDG))
      CALL KUGETR(YCUMAX(NCUTDG))

      CALL KUGETC(CH, L)

      IF (CH(1:2) .EQ. 'SL')  THEN
        DGCUOP(NCUTDG) = 'SL'
      ELSE IF (CH(1:3) .EQ. 'CMP')  THEN
        DGCUOP(NCUTDG) = 'CMP'
        DO  I = 1, NCOMP
          IF (DGCUCO(NCUTDG).EQ.COMP(I))   GO TO 100
        END DO
        CALL MEERRC (mes_id_2,
     +   'DGCUT: Invalid detector component name encountered !!!!')
        GO TO 999
 100    CONTINUE
        DGCUCI(NCUTDG) = I
      ELSE
        CALL MEERRC (mes_id_3,
     +   'DGCUT: Invalid component option encountered (SL or CMP)')
        GO TO 999
      END IF

 999  CONTINUE

      END

************************************************************************
* End of KADGCU
************************************************************************
