
// ******************************************************************
//
// r. spighi 25 jan 2000
//
// Declaration of Histograms and Initialization
//
// ******************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "dq/DQ.h"
#include "dq/DQ_ECAL.h"

#include <CLHEP/Hist/HBookHistogram.h>

//
// function code
//

int
DQ_ECAL_hit_init()
{
  cout<<"DQ_ECAL_hit_init"<<endl;
  // general
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT, 9),"ECAL hit: BX",    221,-0.5,220.5);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,10),"ECAL hit: trig code", 20 ,-0.5,19.5);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,11),"ECAL hit: nr of hitted cells",6000,-0.5,5999.5);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,13),"ECAL hit: Total Energy/IR vs. time (100 ev)",1000,0,1000);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,14),"ECAL hit: Total Energy/IR vs. time (100 ev) Inner",1000,0,1000);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,15),"ECAL hit: Total Energy/IR vs. time (100 ev) Middle",1000,0,1000);
  rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,16),"ECAL hit: Total Energy/IR vs. time (100 ev) Outer",1000,0,1000);

  // energies
 rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,100),"ECAL hit: Total Energy Inner", 200,0.,800.);
 rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,101),"ECAL hit: Total Energy Middle", 200,0.,800.);
 rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,102),"ECAL hit: Total Energy Outer", 200,0.,800.);
 rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,103),"ECAL hit: Total Energy",200,0.,800.);
 rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,104),"ECAL hit: Energy per bx",221,-0.5,220.5);
 rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,105),"ECAL hit: Energy per bx E>1.GeV",221,-0.5,220.5);

 rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,110),"ECAL hit: cell Energy ",200,-0.5,199.5);
 rhp_hbook1(DQ_ID(COMP_ECAL,LVL_HIT,111),"ECAL hit: cell Energy_t",160,0.,4.0);


  // energy cell
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,755),"ECAL hit: cell energy Inner",
	     70,-78.05,78.05,40,-44.60,44.60);
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,756),"ECAL hit: cell energy Middle",
	     80,-223.0,223.0,48,-133.8,133.8);
  rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,757),"ECAL hit: cell energy Outer",
	     56,-312.2,312.2,42,-234.15,234.15);


  // occupancy
 rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,770),"ECAL hit: cell occupancy Inner",
             70,-78.05,78.05,40,-44.60,44.60);
 rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,771),"ECAL hit: cell occupancy Middle ",
             80,-223.0,223.0,48,-133.8,133.8);
 rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,772),"ECAL hit: cell occupancy Outer",
             56,-312.2,312.2,42,-234.15,234.15);

  // occupancy per radius square
 rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,775),"ECAL hit: cell occupancy*radius Inn",
             70,-78.05,78.05,40,-44.60,44.60);
 rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,776),"ECAL hit: cell occupancy*radius Mid",
             80,-223.0,223.0,48,-133.8,133.8);
 rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,777),"ECAL hit: cell occupancy*radius Out",
             56,-312.2,312.2,42,-234.15,234.15);

  // X,Y distribution of ETmax
 rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,780),"ECAL hit: Max Energy_T Inner",
	    70,-78.05,78.05,40,-44.60,44.60);
 rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,781),"ECAL hit: Max Energy_T Middle",
	    80,-223.0,223.0,48,-133.8,133.8);
 rhp_hbook2(DQ_ID(COMP_ECAL,LVL_HIT,782),"ECAL hit: Max Energy_T Outer",
	    56,-312.2,312.2,42,-234.15,234.15);


  return 0;
}




















