 
// *****************************************************************************
//
// source:    DQ_RECO_marple.C
//
// type:      source code
//
// created:   06 Aug 2000
//
// author:    Dr. Andreas Gellrich
//            HERA-B Collaboration
//            Humboldt-University Berlin
//            Physics Department
//            Invalidenstr. 110
//            10115 Berlin
//            Germany
//            email: Andreas.Gellrich@desy.de
//
// called by: DQ_RECO_marple_init()
//            DQ_RECO_marple_evnt( arguments )
//
// hints:     DQ_RECO_marple_init() will be called if DQ/RECO is set
//            DQ_RECO_marple_evnt( arguments ) can be called everywhere
//            use histogram IDs 7000 to 7999
//
// changes:
// 06 Aug 2000 (AG) creation
// 07 Aug 2000 (AG) added flag
//
// *****************************************************************************

// standard includes
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"

//
// function code
//
int
DQ_RECO_marple_init()
{
  ARTE_mark( "DQ_RECO_marple_init 0", 0 );
  cout << "DQ_RECO_marple_init" << endl;

  // check settings
  if( DQ_flag( COMP_RECO, LVL_M_REC ) ){
    // here comes the code to initialize histograms
    //rhp_hbook1( DQ_ID( COMP_RECO,LVL_REC, 7000 ), "RECO marple tracks ", 100, -0.5, 0.5 );
  }

  ARTE_mark( "DQ_RECO_marple_init 1", 0 );
  return 0;
}

//
// function code
//
int
DQ_RECO_marple_evnt( int arguments )
{
  ARTE_mark( "DQ_RECO_marple_evnt 0", 0 );
  
  // check settings
  if( DQ_flag( COMP_RECO, LVL_M_REC ) ){
    // here comes the code to fill histogram
    //rhp_hf1( DQ_ID( COMP_RECO, LVL_REC, 7000 ), x, 1 );
  }

  ARTE_mark( "DQ_RECO_marple_evnt 1", 0 );
  return 0;
}
