
// ******************************************************************
//
// D. Samtleben 10 Aug 1999
//
// Declaration of Histograms and Initialization
//
// changes:
// 27 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
//  4 Nov 1999 (DD) beta=1 radius histogramm 
// 19 Nov 1999 (AG) show up
// 16 Dec 1999 (RP) likelihood histograms DQ_RICH_rec_pid()
// 30 Mar 2000 (DD) fading histos 
// 11 May 2000 (RP) histograms redefined
// 25 May 2000 (DD) event efficiency monitoring, r2p2 particle id
// 16 Jun 2000 (AG) two new hostograms added sigma(tx/ty) vs momen
//  6 Jul 2000 (AG) polished printout
// 10 Jul 2000 (RP) histograms redefined
// *****************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>   

// ONLINE includes
#include "rhp.h"

// ARTE includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_RICH.h"
#include "riter/riter.hh"

/////////////////////  Declare RICH histograms /////////////////////////////
float DQ_RICH_rec_xmin=log(1);
float DQ_RICH_rec_xmax=log(200);
int   DQ_RICH_rec_nbin=20;

int DQ_RICH_rec_init()
{
  // show up
  ARTE_mark( "DQ_RICH_rec_init 0", 0 ); 
  cout << "DQ_RICH_rec_init" << endl;

  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 200),"RICH: Number of RICH rings per event",50,-0.5,49.5);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 201),"RICH: track directions",50,-0.3,0.3,50,-0.3,0.3);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 202),"RICH: Cherenkov angle",400,0.02,0.06);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 203),"RICH: Beta=1 Cherenkov angle",400,0.02,0.06);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 2000),"RICH: Beta=1 Cherenkov angle",400,0.02,0.06);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 2002),"RICH: Current Cherenkov angle",400,0.02,0.06);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 2003),"RICH: Current Beta=1 Cherenkov angle",400,0.02,0.06);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 2004),"RICH: Occupancy Cut Inefficiency",4,-.5,3.5);

  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 2005),"RICH: R2P2",100,0,.02,  100,.7e-3,3.5e-3);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 2006),"RICH: Electrons",50,-4e-4,4e-4);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 2007),"RICH: Pions"    ,50,-4e-4,4e-4);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 2008),"RICH: Kaons"    ,50,-4e-4,4e-4);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 2009),"RICH: Protons"  ,50,-4e-4,4e-4);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 2010),"RICH: Ring id: e,pi,K,p", 6,-.5, 5.5);


  float xmin = DQ_RICH_rec_xmin ;
  float xmax = DQ_RICH_rec_xmax ;
  int   nbin = DQ_RICH_rec_nbin ;

  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 207),"RICH: PID=other,..,..,pi,K,p vs log(p)" ,nbin,xmin,xmax ,6,0,6); 
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 208),"RICH: PID=other,..,..,pi,K,p"  ,6,0,6);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 209),"RICH: PID=other,e,mu,pi,K,p vs log(p)" ,nbin,xmin,xmax ,6,0,6); 
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 210),"RICH: PID=other,e,mu,pi,K,p"  ,6,0,6);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 211),"RICH: rtra->lrother",100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 212),"RICH: rtra->lre"  ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 213),"RICH: rtra->lrmu" ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 214),"RICH: rtra->lrpi" ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 215),"RICH: rtra->lrk"  ,100,0,1);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 216),"RICH: rtra->lrp"  ,100,0,1);

  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 217),"RICH: rtra->hri",100,0,100);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 218),"RICH: rtra->flr",100,0,100);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 219),"RICH: rtra->flr/allrtra",100,0,1);



  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 220),"RICH: log(rtra->lrk/rtra->lrpi)(log(p))"  ,nbin,xmin,xmax,100,-100,100);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 221),"RICH: rtra->lrother(log(p))",nbin,xmin,xmax,100,0,1);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 222),"RICH: rtra->lre(log(p))"  ,nbin,xmin,xmax,100,0,1);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 223),"RICH: rtra->lrmu(log(p))" ,nbin,xmin,xmax,100,0,1);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 224),"RICH: rtra->lrpi(log(p))" ,nbin,xmin,xmax,100,0,1);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 225),"RICH: rtra->lrk(log(p))"  ,nbin,xmin,xmax,100,0,1);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 226),"RICH: rtra->lrp(log(p))"  ,nbin,xmin,xmax,100,0,1);

  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 227),"RICH: rtra->hri(log(p))",nbin,xmin,xmax,100,0,100);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 228),"RICH: rtra->flr(log(p))",nbin,xmin,xmax,100,0,100);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 229),"RICH: rtra->flr/allrtra(log(p))",nbin,xmin,xmax,100,0,1);
  

  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 230),"RICH: sigma(tx)",100,0,0.010);
  rhp_hbook1(DQ_ID(COMP_RICH, LVL_REC, 231),"RICH: sigma(ty)",100,0,0.010);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 233),"RICH: sigma(tx) vs momen.",nbin,xmin,xmax,100,0,0.010);
  rhp_hbook2(DQ_ID(COMP_RICH, LVL_REC, 234),"RICH: sigma(ty) vs momen.",nbin,xmin,xmax,100,0,0.010);

  RITERhbook();

  // show up
  ARTE_mark( "DQ_RICH_rec_init 1", 0 ); 

  return 0; // return error code (0 = okay)
}
