
// ******************************************************************
//
// M. Braeuer / D. Samtleben
//
// changes:
// 20 Oct 1999 (AG) code polishing
// 22 Oct 1999 (AG) polish SVD stuff
// 28 Oct 1999 (AG) use defines from DQ.h
//  1 Nov 1999 (AG) get rid of dq_hid.h
// 19 Nov 1999 (AG) show up
// 30 May 1999 (GS) hits/event histo booking range extended
// ******************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ONLINE includes
#include "rhp.h"

// Arte includes
#include "arte/arte.hh"
#include "farm/farm.hh"
#include "dq/DQ.h"
#include "dq/DQ_SVD.h"

//
// function code
//
int
DQ_SVD_hit_init()
{
  // show up
  ARTE_mark( "DQ_SVD_hit_init 0", 0 ); 
  cout << "DQ_SVD_hit_init" << endl;

  // definitions and Vars for the VDS

#define VDS_MAXPLANES  128
 
#define VDS_plane_l  -0.5  // lower bound for plane
#define VDS_plane_h 127.5  // upper bound for plane
 
//======================================================================
//      now GEDE-independent booking
//======================================================================
  
  rhp_hbook1(DQ_ID(COMP_SVD,LVL_HIT,100),"VDS hits/plane raw",
	     VDS_MAXPLANES,VDS_plane_l,VDS_plane_h);
  rhp_hbook1(DQ_ID(COMP_SVD,LVL_HIT,101),"VDS hits/event raw", 
	     1000,-0.5,1999.5);
  rhp_hbook2(DQ_ID(COMP_SVD,LVL_HIT,102),"VDS occupancy raw",
	     VDS_MAXPLANES,VDS_plane_l,VDS_plane_h, 128,0.,1280.);
  rhp_hbook1(DQ_ID(COMP_SVD,LVL_HIT,301),"VDS no of unused hits/event",
	     300,-0.5,299.5);

  // show up
  ARTE_mark( "DQ_SVD_it_init 1", 0 ); 

  return 0; // return error code (0 = okay)
}
