*CMZ :  1.00/00 22/12/94  20.11.24  by  Dominik Ressing
*-- Author :    Dominik Ressing   12/12/94
************************************************************************
*
* L1GETRP
* written by Dominik Ressing, 12/12/94 12.48.16
*
* This routines action:
*
*
* Arguments  kind         description
*          (in,update,out)
*----------------------------------------------------------------------*
* iTrk        in          Track number
* z           in          z position of point
* x,y         out         x,y for track iTrk at z
* P           out         momentum of track after magnet
*
************************************************************************
c
      SUBROUTINE L1GETRP(iTrk,z,x,y,P)
c
      IMPLICIT NONE
c
#include "l1si/l1param.fi"
#include "l1si/l1geodf.fi"
#include "l1si/l1detdf.fi"
#include "l1si/l1clink.fi"
#include "l1si/rclink.fi"
#include "gean/gcbank.fi"
#include "l1si/rcfdef.fi"
#include "l1si/l1banks.fi"
c
      INTEGER iTrk,Jpo
      REAL    z,x,y,dx,dy,dz,dz0,P
c
#include "l1si/rcfunc.ff"
c
      x = -999999.
      y = -999999.
      P = 0.
c
      CALL L1GETRX(iTrk,Jpo)         ! get pointer to track extra tables row
      IF ( Jpo.eq.0 ) RETURN
c
      dz  = Q(Jpo+L1_TRK_Z2)-Q(Jpo+L1_TRK_Z1)
      dx  = Q(Jpo+L1_TRK_X2)-Q(Jpo+L1_TRK_X1)
      dy  = Q(Jpo+L1_TRK_Y2)-Q(Jpo+L1_TRK_Y1)
      dz0 = z - Q(Jpo+L1_TRK_Z1)
c
      IF ( ABS(dz).lt.1.e-10 ) RETURN   ! only one point there
c
      x = Q(Jpo+L1_TRK_X1)+dx/dz*dz0
      y = Q(Jpo+L1_TRK_Y1)+dy/dz*dz0
      P = Q(Jpo+L1_TRK_PAFTER)
c
      RETURN
c
      END
