#ifndef MuDbNede_h
#define MuDbNede_h 1

//## Class: MuDbNede
//      /**Author:        Boris Fominykh
//
//      Date:             December 20, 1999
//
//      Class:            MuDbNede
//
//      Base Class:       MuDbTable
//
//      Description:
//      This class is for muon NEDE table in DB*/

#include "murec/MuDbTable.h"
#include "murec/MuNede.h"

class MuDbNede : public MuDbTable
{
  public:
    //## Constructor
           MuDbNede();
    //## Destructor
           ~MuDbNede();

    //public methods
      //        /**Add one Nede element to temporary space*/
      int Add(MuNede* pnede);
      //        /**Write all Nede elements from temporary space to DB*/
      int Write();
      //        /**Read all muon Nede elements to temporary space*/
      int Read();
      //        /**Get one Nede element from temporary space*/
      int Get(int* key,MuNede* pnede);
      //        /**release the temporary space*/
      void Release();

    //## Get and Set Operations for Class Attributes
      //        /**Set the number of NEDE elements*/
      void setNned(int nned);

  protected:

      int Nnede;

  private:

    static const int NelInt   = 16;
    static const int NelFloat = 48;
    static const int NelChar  = 18;
      int    Status;
      int    Ncollect;
      int    SizeW;
      int*   ElIntW;
      float* ElFlW;
      char*  ElChW;
      
      //        /** Initialization */
      void Ini();
      //        /** Book temporary space */
      int Book();
};

//## Get and Set Operations for Class Attributes (inline)
inline void MuDbNede::setNned(int nned)
{
  Nnede=nned;
}

#endif
