#ifndef MuDbNesl_h
#define MuDbNesl_h 1

//## Class: MuDbNesl
//      /**Author:        Boris Fominykh
//
//      Date:             December 21, 1999
//
//      Class:            MuDbNesl
//
//      Base Class:       MuDbTable
//
//      Description:
//      This class is for muon NESL table in DB*/

#include "murec/MuDbTable.h"
#include "murec/MuNesl.h"

class MuDbNesl : public MuDbTable
{
  public:
    //## Constructor
           MuDbNesl();
    //## Destructor
           ~MuDbNesl();

    //public methods
      //        /**Add one Nesl element to temporary space*/
      int Add(MuNesl* pnesl);
      //        /**Write all Nesl elements from temporary space to DB*/
      int Write();
      //        /**Read all muon Nesl elements to temporary space*/
      int Read();
      //        /**Get one Nesl element from temporary space*/
      int Get(int* key,MuNesl* pnesl);
      //        /**release the temporary space*/
      void Release();

    //## Get and Set Operations for Class Attributes
      //        /**Set the number of NESL elements*/
      void setNnesl(int nnesl);

  protected:

      int Nnesl;

  private:

    static const int NelInt   = 25;
    static const int NelFloat = 8;
    static const int NelChar  = 6;
      int    Status;
      int    Ncollect;
      int    SizeW;
      int*   ElIntW;
      float* ElFlW;
      char*  ElChW;
      
      //        /** Initialization */
      void Ini();
      //        /** Book temporary space */
      int Book();
};

//## Get and Set Operations for Class Attributes (inline)
inline void MuDbNesl::setNnesl(int nnesl)
{
  Nnesl=nnesl;
}

#endif
