#ifndef MuDbTube_h
#define MuDbTube_h 1

//## Class: MuDbTube
//      /**Author:        Boris Fominykh
//
//      Date:             December 26, 1999
//
//      Class:            MuDbTube
//
//      Base Class:       MuDbChamber
//
//      Description:
//      This class is to describe the configuration of muon tube chambers,
//      This class can be used without ARTE.*/

#include "murec/MuDbNesl.h"
#include "murec/MuDbNede.h"
#include "murec/MuDbConfig.h"
#include "murec/MuDbHots.h"
#include "murec/MuDbChamber.h"

typedef unsigned int   LWord;
typedef unsigned short Word;

class MuDbTube:  public MuDbChamber
{
  public:
    //## Constructor
           MuDbTube();
    //## Destructor
           ~MuDbTube();

    //public methods
      //        /** Clear the object */
      void Clear();
      //        /** Set the cable connection */
      int SetConnect();
      //        /** Initialization */
      int Ini();
      //        /**Print the contents of the object*/
      void Print();

    int Ivalid;
    static const Word TubeGeoNx     = 30;
    static const Word TubeGeoUpDown = 2;
    static const Word TubeGeoLay    = 3;
    static const Word TubeGeoSl     = 2;
    static const Word TubeGeoSd     = 2;

  //## number of tube chambers
    Word NchambT[TubeGeoSl][TubeGeoLay][TubeGeoUpDown];
  //## number of wires in the tube chamber
    Word TubeGeoWire;
  //## gede
    LWord TubeGede[TubeGeoSl][TubeGeoLay][TubeGeoUpDown][TubeGeoNx][TubeGeoSd];
  //## chamber names
    char ChamListT[TubeGeoSl][TubeGeoLay][TubeGeoUpDown][TubeGeoNx][9];
  //## number of half-connectors per chamber
    Word NconnT[TubeGeoSl][TubeGeoLay][TubeGeoUpDown][TubeGeoNx];
    static const Word Nconn      = 2;
  //## number of connected wires by half-connector
    static const Word  NumbT = 8;
  //## mask
    Word  MaskT[TubeGeoSl][TubeGeoLay][TubeGeoUpDown][TubeGeoNx][Nconn];
  //## first connected wire number
    Word  Wire1T[TubeGeoSl][TubeGeoLay][TubeGeoUpDown][TubeGeoNx][Nconn][TubeGeoSd];
  //## first bit inside crate
    Word  Nbit1T[TubeGeoSl][TubeGeoLay][TubeGeoUpDown][TubeGeoNx][Nconn][TubeGeoSd];
  //##  crate
    Word  CrateT[TubeGeoSl][TubeGeoLay][TubeGeoUpDown][TubeGeoNx];
  //## step (+2 or -2)
    int  StepT[TubeGeoSl][TubeGeoLay][TubeGeoUpDown][TubeGeoNx];

  protected:

  private:

      //        /** Set the tube chamber structure */
      int SetStruct();
};

#endif
