*
* B.Fominykh  28.07.97
*
* selection of MC tracks and produced hits
      SUBROUTINE MUISEL(PMIN,NHT,IHT,NMTT)
*     ====================================
* input:  PMIN - min momentum of MC track
* output: NHT  - number of produced hits
*         IHT(NHT) - list of produced HITB hits
*         NMTT - MC track number
*
      IMPLICIT NONE
      REAL PMIN
      INTEGER HITMAP(4,4),NMT,J,MUSL,LAY
      INTEGER ISEL,IH,JH,IM,JMT,ID,IHH,JHH,I
      REAL PX,PY,PZ,P,P2
      INTEGER NHT,IHT(1),NMTT
*
#include "murec/MUCKALF.fi"
#include "murec/MUCONT.fi"
#include "murec/MUCTAB.fi"
#include "auto/MTRA.fi"
#include "arte/Arte.fi"

#include "arte/Arte.ff"
C----+===1=========2=========3=========4=========5=========6=========7==********
*
      NHT=0
      NMTT=0
* check point
      IF(JTMP9.LE.0)       GOTO 900
      IF(IQ(JTMP9+1).LE.0) GOTO 900
      IF(IQ(JTMP9+2).LE.0) GOTO 900
* loops over hits
      ISEL=0
      DO 100 IH=1,IQ(JTMP9+2)
        JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
        IF(IQ(JH+14).LE.0) GOTO 100
* loops over MC tracks
        DO 80 IM=1,IQ(JH+14)
          NMT=IQ(JH+14+IM)
          IF(NMT.LE.0) GOTO 80
          JMT = JMTRA+IQ(JMTRA+1)*(NMT-1)+2
          ID  = IQ(JMT+JMTRA_TOPP)
          PX  = Q(JMT+JMTRA_PX)
          PY  = Q(JMT+JMTRA_PY)
          PZ  = Q(JMT+JMTRA_PZ)
          P2  = PZ*PX+PY*PY+PZ*PZ
          IF(P2.GT.1.E-1) THEN
            P = SQRT(P2)
          ELSE
            P=0.
          ENDIF          
* p > p_min
          IF(P.LT.PMIN) GOTO 70
* fill the hit-map
          DO I=1,4
            DO J=1,4
              HITMAP(I,J)=0
            ENDDO
          ENDDO
          DO 10 IHH=IH,IQ(JTMP9+2)
            JHH=JTMP9+IQ(JTMP9+1)*(IHH-1)+2
            IF(IQ(JHH+14).LE.0) GOTO 10
          DO 5 I=1,IQ(JHH+14)
            IF(IQ(JHH+14+I).EQ.NMT) THEN
              MUSL=IQ(JHH+3)
              LAY =IQ(JHH+4)
              HITMAP(MUSL,LAY)=1
              GOTO 10
            ENDIF
   5      CONTINUE
  10      CONTINUE

* control the hit-map
*   MU1
          IF(HITMAP(1,4).GE.1) GOTO 21
          IF(HITMAP(1,1)+HITMAP(1,2)+HITMAP(1,3)
     +                               .GE.2) GOTO 21
          GOTO 70
  21      CONTINUE
*   MU3
          IF(HITMAP(3,2).GE.1) GOTO 23
          IF(HITMAP(3,1).GE.1) GOTO 23
          GOTO 70
  23      CONTINUE
*   MU4
          IF(HITMAP(4,2).GE.1) GOTO 24
          IF(HITMAP(4,1).GE.1) GOTO 24
          GOTO 70
  24      CONTINUE
          ISEL=1
  70      CONTINUE
*
* collect hits and exclude the references to NMT
          DO 76 IHH=IH,IQ(JTMP9+2)
            JHH=JTMP9+IQ(JTMP9+1)*(IHH-1)+2
            IF(IQ(JHH+14).LE.0) GOTO 76
          DO 75 I=1,IQ(JHH+14)
            IF(IQ(JHH+14+I).EQ.NMT) THEN
              IF(ISEL.EQ.1) THEN
                IF(NHT.LT.100) THEN 
                  NHT=NHT+1
                  IHT(NHT)=IHH
                ENDIF
              ENDIF
              IQ(JHH+14+I)=0
              GOTO 76
            ENDIF
  75      CONTINUE
  76      CONTINUE
          IF(ISEL.EQ.1) GOTO 900
  80    CONTINUE
 100  CONTINUE
*
 900  CONTINUE
      

      IF(NHT.GT.0) THEN
        NMTT=NMT
* fix Z0
        IH=IHT(NHT)
        JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
        PARAM(1)=Q(JH+6)
      ENDIF
*
      IF(NHT.GT.0) THEN
       IF(IPRLG.GE.1) WRITE(LLOGF,1001) NMT,ID,P
       IF(IPRSC.GE.1) PRINT 1001, NMT,ID,P
 1001 FORMAT(1X,'MUISEL: selected MC track',I5,'  ID',I3,
     +         '  p',F8.3)
       IF(IPRLG.GE.2)WRITE(LLOGF,1003) ((HITMAP(I,J),J=1,4),I=1,4)
       IF(IPRSC.GE.2) PRINT 1003, ((HITMAP(I,J),J=1,4),I=1,4)
 1003 FORMAT(9X,'hitmap:',4(4I2,3X))
        DO 110 I=1,NHT
          IH=IHT(I)
          JH=JTMP9+IQ(JTMP9+1)*(IH-1)+2
       IF(IPRSC.GE.3)
     + PRINT 1002,I,IQ(JH+1),(IQ(JH+J),J=3,5),(Q(JH+J),J=6,12)
       IF(IPRLG.GE.3)
     + WRITE(LLOGF,1002) I,IQ(JH+1),(IQ(JH+J),J=3,5),(Q(JH+J),J=6,12)
 1002 FORMAT(5X,I3,' HITB',I6,' musl,lay,type',3I2,' z,sinr,d(x)',
     +       F7.1,F7.3,F7.1,/,20X,' Y1,Y2',2F7.1,' SIGx,y',2F7.2)
  110   CONTINUE
      ELSE
       IF(IPRSC.GE.1) PRINT*, ' MUISEL: no track'
       IF(IPRLG.GE.1) WRITE(LLOGF,*) ' MUISEL: no track'
      ENDIF
*
      RETURN
      END









