// 
//  Author:  Rainer Mankel                     Created:  30-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "rang/CompLay.hh"

rangerCompLay::rangerCompLay(const pair<int,rangerSubLayerSet>& p1) {
  cmpSLS.push_back(p1);
}

rangerCompLay::rangerCompLay(const pair<int,rangerSubLayerSet>& p1,
		const pair<int,rangerSubLayerSet>& p2) {
  cmpSLS.push_back(p1);
  cmpSLS.push_back(p2);
}

rangerCompLay::rangerCompLay(const pair<int,rangerSubLayerSet>& p1,
		const pair<int,rangerSubLayerSet>& p2,
		const pair<int,rangerSubLayerSet>& p3) {
  cmpSLS.push_back(p1);
  cmpSLS.push_back(p2);
  cmpSLS.push_back(p3);
}

rangerSubLayerSet* rangerCompLay::slSet(int cmp) {
  for (vector<pair<int,rangerSubLayerSet> >::iterator vpi=cmpSLS.begin();
	 vpi != cmpSLS.end(); ++vpi) {
    if (((*vpi).second).gCmp == cmp) return &(*vpi).second;
  }
#ifdef FINDWARN
  cout << "rangerCompLay::slSet: slset not found for cmp=" << cmp << endl;
#endif
  return 0;
}

int rangerCompLay::getGlay(int cmp) {
  for (vector<pair<int,rangerSubLayerSet> >::iterator vpi=cmpSLS.begin();
	 vpi != cmpSLS.end(); ++vpi) {
    if ( ((*vpi).second).gCmp == cmp ) {
      return (*vpi).first;
      //      return ((*vpi).second).gLayer;
    }
  }
#ifdef FINDWARN
  cout << "rangerCompLay::getGlay: not found for cmp=" << cmp << endl;
#endif
  return 0;
}

void rangerCompLay::dump(const int level) {
  cout << " CompLay: number of entries=" << cmpSLS.size() << endl;
  if (level > 1) {
    for (vector<pair<int,rangerSubLayerSet> >::iterator vpi=cmpSLS.begin();
	 vpi != cmpSLS.end(); ++vpi) {
      cout << "   nativeLSN=" << (*vpi).first
	   << " cmp=" << ((*vpi).second).gCmp
	   << " gLayer=" << ((*vpi).second).gLayer
	   << " su1=" << ((*vpi).second).subLay1
	   << " su2=" << ((*vpi).second).subLay2
	   << endl;
    }
  }
}
