// 
//  Author:  Rainer Mankel                     Created:  23-Apr-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include "rang/SeedTableau.hh"
#include "rang/SeedSet.hh"
#include "rang/Domain.hh"

rangerSeedTableau::rangerSeedTableau(rangerDomain* dom,const int direction){
  domain = dom;
  direct = direction;
}


void rangerSeedTableau::dump(const int level) {
  cout << " rangerSeedTableau domain " << domain->nam()
       << " direction " << direct
       << " number of seedSets " << sss.size()
       << endl;

  if (level > 1) {
    for (vector<rangerSeedSet*>::iterator ssi=sss.begin();
	 ssi != sss.end(); ++ssi) {
      (*ssi)->dump(level-1);
    }
  }
}
