// 
//  Author:  Rainer Mankel                     Created:  28-May-99
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

#include <iostream.h>
#include <iomanip.h>
#include "rang/StatItem.hh"

rangerStatItem::rangerStatItem() {
  countGood = 0;
  countAll = 0;
}

void rangerStatItem::count(const int level) {

  switch (level) {
  case 0:
    ++countAll;
    break;
  case 1:
    ++countGood;
    break;
  }
}


ostream& operator<<(ostream &os,const rangerStatItem &si){
  if (si.countAll > 0) {
    os << "  all= " 
       << setw(6)
       << si.countAll << "  good= " << setw(6) << si.countGood
       << "  fraction= " 
       << setiosflags(ios::fixed) << setw(6) << setprecision(2)
       << 100* ((float) si.countGood) / ((float) si.countAll)
       << "%";  
  }
  else {
    os << "  all= " << si.countAll << "  good= " << si.countGood;
  }
  return os;
}

    
