// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 
#include <iostream.h>
#include <math.h>
#include "rang/VolBox.hh"
#include "rang/Arrow.hh"

//-- Constructor
rangerVolBox::rangerVolBox(){};

//-- Constructor
rangerVolBox::rangerVolBox( rangerGeWa* gewa ) : rangerVolume( gewa ) {
};

//-- Destructor
rangerVolBox::~rangerVolBox(){};

double rangerVolBox::sLength(double zz,
			  double x,
			  double y,
			  double tx,
			  double ty){

  rangerArrow a(zz,x,y,tx,ty);
  rotateArrow(a);

  double zC = 0.5 * (Gewa->zmin() + Gewa->zmax());

  double xP = a.x + (zC - a.z) * a.tx;  // coordinates in ACS
  double yP = a.y + (zC - a.z) * a.ty;  // see Hera-B 97-090 p 67
  if (xP < Gewa->xmin()) return 0;
  if (xP > Gewa->xmax()) return 0;
  if (yP < Gewa->ymin()) return 0;
  if (yP > Gewa->ymax()) return 0;

  return sqrt(1 + a.tx * a.tx + a.ty * a.ty);

};


