// 
//  Author:  Rainer Mankel                     Created:  29-Sep-98
//           Humboldt University Berlin        Modified:  
//  Email:   mankel@ifh.de                     HERA-B Collaboration
// 

// class rangerVolTubs
// volume class for tube segment

#ifndef rangerVolTubs_HH
#define rangerVolTubs_HH

#include "rang/Volume.hh"
#include "rang/GeWa.hh"

class rangerVolTubs : public rangerVolume {
  
public:
  rangerVolTubs(); // default constructor
  rangerVolTubs( rangerGeWa* gewa ); // constructor from gewa
  ~rangerVolTubs(); // destructor

  double sLength(double zz,
		 double x,
		 double y,
		 double tx,
		 double ty); // return traversed length
                             // in units of (zmax-zmin)
  const float zMean();   // mean z for sort
};

#endif
