// 
//  Author:  Alexander Spiridonov              Created:  12.06.99
//
//  Email:   spiridon@ifh.de                   HERA-B Collaboration
// 
// rgextmrse.C
//
//                     create MUON-RICH seeds for ranger-external
//
#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include "arte/RSEG_cmp.hh"
#include "arte/arte.hh"
#include "rang/rgExtDef.hh"
#include "rang/zfparext.hh"
#include "rang/zfextse.hh"

// Prototypes


extern "C" void rgextmrse_() {

// initialization
#ifdef rgExtHist
  int id0 = zfparext_.id_hist; 
  int id;
  float w = 1.; float v;
  
#endif

  zfextse_.N_ext_seed = 0; 


//                                      loop on segments in muon
 
  for( ArteTableIterator <RSEG> segmu; 
       segmu.valid(); segmu.next() )
    {
      int CUT = 0;
      if( !(segmu->fit >= 0) || !(segmu->cmp & Rsegc::muon) 
	  || !( (segmu->cmp & Rsegc::bitsign) == 0 ))
	{
	  goto NEXTmuon;
	}

      float z_mu,x_mu,y_mu,tx_mu,ty_mu,q_mu;
      z_mu = zfparext_.z_match_mu;   
      x_mu = segmu->xf + ( z_mu - segmu->zf ) * segmu->txf;
      y_mu = segmu->yf + ( z_mu - segmu->zf ) * segmu->tyf;

      tx_mu = segmu->txf;
      ty_mu = y_mu / z_mu;
//    ty_mu = segmu->tyf;
      q_mu = - tfqptest_( z_mu, x_mu, tx_mu) * 1.031;

//      cout << "rgextmrse : q= " << q_mu 
//	   << "                   muon is accepted" << endl;

//                                              loop on segments in rich
      for( ArteTableIterator <RSEG> segri;
	   segri.valid(); segri.next() )
	{
	  if( segri->fit >= 0 && segri->cmp & Rsegc::rich
	      && (segri->cmp & Rsegc::bitsign)  == 0  )
	    {

#ifdef rgExtHist  
	      hf1_(id=id0+223, v = ty_mu - segri->tyf, w);
#endif
//                                                                 CUT 1

	if(fabsf(ty_mu - segri->tyf) > zfparext_.dmax_ty_muri )
	  {
//	    cout << "rgextmrse :   CUT1 , ty_mu - segri->tyf " 
//		 <<  (ty_mu -segri->tyf) << endl;
	    CUT = 1;
	    goto NEXTrich;
	  }

	      if(zfextse_.N_ext_seed < NMAX_SEED )
		{
		  q_mu = - tfqptest_( z_mu, x_mu, segri->txf) * 1.031;

		  x_mu = x_mu + (  segmu->zf - z_mu ) * segri->txf;
		  y_mu = y_mu + (  segmu->zf - z_mu ) * segri->tyf;

		  cout << "rgextmrse : N_ext_seed " 
		       << zfextse_.N_ext_seed << endl;
		  int seed;
		  seed = zfextse_.N_ext_seed;

		  zfextse_.z_seed[seed] = segmu->zf;

		  zfextse_.x_seed[seed] = x_mu;
		  zfextse_.y_seed[seed] = y_mu;
		  zfextse_.tx_seed[seed] = segri->txf;
		  zfextse_.ty_seed[seed] = segri->tyf;
		  zfextse_.q_seed[seed] = q_mu;
		  zfextse_.cov_seed[seed][0] = segmu->cvf[0];
		  zfextse_.cov_seed[seed][1] = segmu->cvf[1];
		  zfextse_.cov_seed[seed][2] = segmu->cvf[2];
//		  zfextse_.cov_seed[seed][5] = 0.26e-6;
//		  zfextse_.cov_seed[seed][9] = 0.49e-6; 
		  zfextse_.cov_seed[seed][5] = 0.26e-6 * 10.;
		  zfextse_.cov_seed[seed][9] = 0.49e-6 * 10.; 
		  zfextse_.cov_seed[seed][14] = q_mu * q_mu * 0.08 * 0.08;
		  zfextse_.seg_VDS[seed] = 0; 
		  zfextse_.seg_MUON[seed] = segmu.index(); 
		  zfextse_.seg_ECAL[seed] = 0; 
		  zfextse_.seg_RICH[seed] = segri.index(); 
		  zfextse_.seg_OT[seed] = 0; 
		  zfextse_.track_MC[seed] = 0; 

		  ++zfextse_.N_ext_seed;
		}

	    }
    NEXTrich:
#ifdef rgExtHist
	  if(CUT > 0) 
	    {
	      cout << " rgextmrse :                             mrse CUT= " 
		   << CUT << endl;  
	    }
#endif
	  CUT = 0;
	}

    NEXTmuon:
      CUT = 0;
    }
  return;

// END998:

#ifdef rgExtHist
//  cout << " rgextcrse :                                      END998 CUT= " 
//       << CUT << endl;  
#endif

  return;
}
