C23456789012345678901234567890123456789012345678901234567890123456789012
C        |         |         |         |         |         |         | |
C       10        20        30        40        50        60        7072
*
*CMZ :          01/11/96  13.41.45  by  T. Oest
*-- Author :    T. Oest   30/05/96
* new versionn: 14.4.97 T. Kuhn-Sander
*
      SUBROUTINE RKD2 (UPDATE, H, EC, RKH)
*
************************************************************************
*
* Description: returns the derivatives for fixed tracking length H
*
* Called from:
*
* External references:
*
* Argument in/out description
* UPDATE   in      = .TRUE. the derivatives will be updated
* H        in      step size
* FAC      in      Qc/p*sign(cos gamma)
* RKH      in/out  derivatives d POUT(5) / d PIN(5)
*
************************************************************************
*
      IMPLICIT NONE
*
#include "arte/Arte.fi"
*
      DOUBLE PRECISION H, RKH(5,5), A
      DOUBLE PRECISION RKWORK(5,5), DKDP(6,5,5)
      DOUBLE PRECISION SUM, EC, FAC
      INTEGER          I, J, L, M, N, II, IC
      LOGICAL          UPDATE
*
COME: common block from rkstep.
      DOUBLE PRECISION B(15), C(6), CST(6), PSTEPS(6,6), K(6,5)
      DOUBLE PRECISION BFIELD(6,3), FSTEPS(6,2), HEC
*
      SAVE   RKWORK, DKDP
*
      COMMON /CRKUT2/  PSTEPS, B, C, CST, K, BFIELD, FSTEPS
#include "arte/Arte.ff"
*
*
COME: set the values of the constant field-elements.
*
      DATA RKWORK(1,1), RKWORK(1,2) /1.0D0, 0.0D0/
      DATA RKWORK(2,1), RKWORK(2,2) /0.0D0, 1.0D0/
      DATA RKWORK(3,1), RKWORK(3,2) /0.0D0, 0.0D0/
      DATA RKWORK(3,3)              /1.0D0/
      DATA RKWORK(4,1), RKWORK(4,2) /0.0D0, 0.0D0/
      DATA RKWORK(4,3), RKWORK(4,4) /0.0D0, 1.0D0/
      DATA RKWORK(5,1), RKWORK(5,2) /0.0D0, 0.0D0/
      DATA RKWORK(5,3), RKWORK(5,4) /0.0D0, 0.0D0/
      DATA RKWORK(5,5) /1.0D0/
*
*
*
      DATA DKDP /150*0.0D0/
*
************************************************************************
COME:   comparation of the variables with the text
COME:   ------------------------------------------
COME:DFDP(5,5)   = DFDP(L,J)   : L = component of the function vector f
COME:                            J = component of the vector xi
COME:                                DFDP(1,1) = df_2/dxi_2
COME:                                DFDP(1,5) = df_2/dxi_6
COME:                                DFDP(5,1) = df_6/dxi_2
COME:                                DFDP(5,5) = df_6/dxi_6
COME:
COME:DKDP(6,5,5) = DKDP(M,L,J) : M = sum limit of vector phi
COME:                            L = component of the function vector f
COME:                            J = component of the vector xi
COME:                                DKDP(1,1,1) = dk^1_2/dxi_2
COME:                                DKDP(6,1,1) = dk^6_2/dxi_2
COME:                                DKDP(1,5,1) = dk^1_6/dxi_2
COME:                                DKDP(1,1,5) = dk^1_6/dxi_6
COME:
COME:RKH(5,5) = RKH(L,J)       : L = component of the function vector f
COME:                            J = component of the vector xi
COME:                                RKH(1,1) = dxi_2,n+1/dxi_2,n
COME:                                RKH(1,5) = dxi_2,n+1/dxi_6,n
COME:                                RKH(5,1) = dxi_6,n+1/dxi_2,n
COME:                                RKH(5,5) = dxi_6,n+1/dxi_6,n
************************************************************************
*
COME: get DFDP and DKDP.
*
*
      HEC = H * EC
      FAC = PSTEPS(1,6)*HEC
*
      DKDP(1,3,5) =  HEC * FSTEPS(1,1)

      DO I=2,6
*
         IC  = (I-1)*(I-2)/2
*
         SUM = 0.0D0
         DO N=1,I-1
            II  = IC + N
            SUM = SUM + B(II) * DKDP(N,3,5)
         ENDDO
         DKDP(I,1,5) = H * SUM

         DKDP(I,3,5) = HEC * FSTEPS(I,1)
*
      ENDDO
*
************************************************************************
*
COME: functional matrix for this step.
*
      IF (UPDATE) THEN
       RKWORK(1,3) = H
       RKWORK(1,5) = C(1) * DKDP(1,1,5) + C(3) * DKDP(3,1,5) +
     &               C(4) * DKDP(4,1,5) + C(6) * DKDP(6,1,5) 
       RKWORK(2,4) = H
       RKWORK(3,5) = C(1) * DKDP(1,3,5) + C(3) * DKDP(3,3,5) +
     &               C(4) * DKDP(4,3,5) + C(6) * DKDP(6,3,5) 
*
COME: matrix multiplication to update the error matrix.
*
*
         RKH(1,3) =               RKH(1,3) + 
     &              RKWORK(1,3)
         RKH(1,4) =               RKH(1,4) + 
     &              RKWORK(1,3) * RKH(3,4)
         RKH(1,5) =               RKH(1,5) + 
     &              RKWORK(1,3) * RKH(3,5) + 
     &              RKWORK(1,5)
*
         RKH(2,4) =               RKH(2,4) + 
     &              RKWORK(2,4)
*
         RKH(3,5) =               RKH(3,5) + 
     &              RKWORK(3,5)
*
*
      ELSE
       RKH(1,1) = 1.0D0
       RKH(2,2) = 1.0D0
       RKH(3,3) = 1.0D0
       RKH(4,4) = 1.0D0
       RKH(5,5) = 1.0D0

       RKH(1,3) = H
       RKH(1,5) = C(1) * DKDP(1,1,5) + C(3) * DKDP(3,1,5) +
     &            C(4) * DKDP(4,1,5) + C(6) * DKDP(6,1,5) 
       RKH(2,4) = H
       RKH(3,5) = C(1) * DKDP(1,3,5) + C(3) * DKDP(3,3,5) +
     &            C(4) * DKDP(4,3,5) + C(6) * DKDP(6,3,5) 
      ENDIF
*
*
************************************************************************
*
COME: End of RKD2
*
      END
*
************************************************************************
