*-- Author :    Rainer Mankel   16/05/95

      subroutine tffilx(ih,dlnext,jpl,ift,izf,izfnew)

*     **** absorb the next hit (0-deg tracking)
      implicit none
#include "rang/zseed.fi"


#include "rang/zf.fi"
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"

#include "pris/hgmagnhelp.fi"

      integer ih, jpl, izf, izfnew, xsig_min, xsig_max, del_xsig, xsig,
     +        jzf, ift, jft, ii, jj, tumchit, imc,  
     +        dlnext, cmp
      integer message_id_1
      double precision dz, dx, cs_thetx, dnoise, xm_p, xr_p,
     +                 cr_p, hch, kalman(dimp,dimm), ihk
      real wc(3), xxx(2), yyy(2), pnoise, pinv

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/MTRA.fi"

      save    message_id_1
      data    message_id_1 /1/

#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/MTRA.ff"

      izfnew = 0

      if (.not.l_2dx) then
       print *,' () tffilx: 2dx only!'
       go to 999
      endif

      if (diag_level.ge.5)
     +  print *,' tffilx: absorb ih, jpl, imc=', ih, jpl, tumchit(ih)

      if (igede_cmp(jpl).eq.2) then
       xsig_min = -1
       xsig_max = +1
       del_xsig = +2
      else
       xsig_min = 0
       xsig_max = 0
       del_xsig = +2
      endif

      dz = fhitb_z(ih) - z_zf(izf)

*     **** loop over L/R signs
      do 10 xsig=xsig_min,xsig_max,del_xsig

       if (n_zf.ge.nzfmx) then
        call mepric(message_id_1,3,
     +       'tffilx: ranger buffer at limit, branch aborted')
        go to 999
       endif
       if (nca_ft.ge.ncamx) then
        call mepric(message_id_1,3,
     +       'tffilx: ranger buffer at limit, branch aborted')
        go to 999
       endif

       jzf = n_zf + 1

*      **** Kalman filter prediction
       xp_zf(1,jzf) = xx_zf(1,izf) + dz * xx_zf(3,izf)
       xp_zf(3,jzf) = xx_zf(3,izf)

       imc = tumchit(ih)

*      **** real life: use momentum estimate
       pinv = abs( xx_zf(5,izf) )
       pinv = amin1(pinv,1.)    ! truncate to 1 GeV
*      **** fudge factors for moliere tails & slope & stereo planes
       dnoise = 3.3d0 * fgede_ms(jpl) * pinv**2
       if (diag_level.ge.5)
     +           print *,' fgede_ms(jpl), pinv, dnoise=',
     +           fgede_ms(jpl), pinv, dnoise
       cp_zf(1,1,jzf) = cx_zf(1,1,izf) + 2.d0 * cx_zf(1,3,izf) * dz
     +                                 + cx_zf(3,3,izf) * dz**2
       cp_zf(1,3,jzf) = cx_zf(1,3,izf) + cx_zf(3,3,izf) * dz
       cp_zf(3,1,jzf) = cp_zf(1,3,jzf)
       cp_zf(3,3,jzf) = cx_zf(3,3,izf) + dnoise

       if (diag_level.ge.5) then
        print *,' tffilx: pred=', xp_zf(1,jzf),
     +         ' error ', dsqrt( cp_zf(1,1,jzf) ), 'dz=', dz
        print *,' cp_zf(1,1,jzf), cp_zf(1,3,jzf), cp_zf(3,3,jzf)=',
     +           cp_zf(1,1,jzf), cp_zf(1,3,jzf), cp_zf(3,3,jzf)
       endif

*      **** projection
       if (igede_cmp(jpl).eq.2) then
        xm_zf(1,jzf)   = xsig * abs( fhitb_q(ih) )
        cm_zf(1,1,jzf) = fhitb_r(ih)**2
        dx = (xp_zf(1,jzf) - fhitb_x(ih))
        xm_p = dx
        xr_p = xsig * abs( fhitb_q(ih) ) - xm_p
        h_zf(1,1,jzf) = 1.
        h_zf(1,3,jzf) = 0.
        hch = cp_zf(1,1,jzf)
        cr_p = fhitb_r(ih)**2 + hch
       elseif (igede_cmp(jpl).eq.3) then
        xm_zf(1,jzf)   = fhitb_x(ih)
        cm_zf(1,1,jzf) = fhitb_r(ih)**2
        xm_p = xp_zf(1,jzf)
        xr_p = fhitb_x(ih) - xm_p


        h_zf(1,1,jzf) = 1.
        h_zf(1,3,jzf) = 0.
        hch = cp_zf(1,1,jzf)
        cr_p = fhitb_r(ih)**2 + hch
       else
        print *,' tffilx: non-supported type for jpl=', jpl
       endif

       if (diag_level.ge.5) then
               print *,' tffilx: fhitb_x(ih), xm_p, xr_p, er_p=',
     +         fhitb_x(ih), xm_p, xr_p, dsqrt(cr_p)

               print *,' hch, fhitb_r(ih)**2, cr_p=',
     +           hch, fhitb_r(ih)**2, cr_p
       endif

*      **** decision
       if (dabs(xr_p).gt.dsqrt(chmax_x_zfpar*cr_p)) go to 10

*      **** filter point
       do ii=1,3,2
        kalman(ii,1) = ( cp_zf(ii,1,jzf) * h_zf(1,1,jzf)
     +                 + cp_zf(ii,3,jzf) * h_zf(1,3,jzf) ) / cr_p
       enddo

*      **** updated x value
       do ii=1,3,2
        xx_zf(ii,jzf) = xp_zf(ii,jzf) + kalman(ii,1) * xr_p
       enddo
       xx_zf(2,jzf) = 0.
       xx_zf(4,jzf) = 0.
       xx_zf(5,jzf) = xx_zf(5,izf) ! relay momentum estimate

*      **** updated cov matrix
       do ii=1,5
        do jj=1,5
         cx_zf(ii,jj,jzf) = 0.
        enddo
       enddo

       if (diag_level.ge.5) then
        print *,' cp_zf(1,1,jzf)...cp_zf(3,3,jzf)=',
     +     cp_zf(1,1,jzf), cp_zf(3,1,jzf), cp_zf(1,3,jzf),
     +     cp_zf(3,3,jzf)

        print *,' kalman(1,1), kalman(3,1)=',
     +            kalman(1,1), kalman(3,1)

        print *,' xr_p=', xr_p
       endif

       cx_zf(1,1,jzf) = (1. - kalman(1,1) * h_zf(1,1,jzf))
     +                  * cp_zf(1,1,jzf)
     +                + (- kalman(1,1) * h_zf(1,3,jzf))
     +                  * cp_zf(3,1,jzf)
       cx_zf(3,1,jzf) = (- kalman(1,1) * h_zf(1,1,jzf) )
     +                * cp_zf(3,1,jzf)
     +                + (1. - kalman(3,1) * h_zf(1,3,jzf))
     +                * cp_zf(3,1,jzf)
       cx_zf(1,3,jzf) = cx_zf(3,1,jzf)
       cx_zf(3,3,jzf) = (- kalman(3,1) * h_zf(1,1,jzf))
     +                * cp_zf(1,3,jzf)
     +                + (1. - kalman(3,1) * h_zf(1,3,jzf))
     +                * cp_zf(3,3,jzf)

       if (diag_level.ge.5) then
        print *,' cx_zf(1,1,jzf)...cx_zf(3,3,jzf)=',
     +     cx_zf(1,1,jzf), cx_zf(3,1,jzf), cx_zf(1,3,jzf),
     +     cx_zf(3,3,jzf)
       endif

*      **** updated residual
       ihk = 1. - h_zf(1,1,jzf) * kalman(1,1)
     +          - h_zf(1,3,jzf) * kalman(3,1)

       xr_zf(1,jzf) = xr_p * ihk
       cr_zf(1,1,jzf) = cm_zf(1,1,jzf) * ihk
       if (diag_level.ge.5) then
        print *,'>ihk, xr_zf(1,jzf), cr_zf(1,1,jzf)=',
     +            ihk, xr_zf(1,jzf), cr_zf(1,1,jzf)
        print *,' h_zf(1,1,jzf), h_zf(1,3,jzf), cr_zf(1,1,jzf)=',
     +            h_zf(1,1,jzf), h_zf(1,3,jzf), cr_zf(1,1,jzf)
       endif

*      **** updated chi2 contribution
       ch_zf(jzf) = xr_zf(1,jzf)**2 / cr_zf(1,1,jzf)

*      **** cut
       if (ch_zf(jzf).gt.chmax_x_zfpar) go to 10

*      **** accept hit
       hit_zf(jzf)   = ih
       nhit_zf(jzf) = nhit_zf(izf) + 1
       plane_zf(jzf) = ihitb_gede(ih)
       cmp = igede_cmp(plane_zf(jzf))
       if (cmp.le.maxcmp_zfpar) then
          whit_zf(jzf) = whit_zf(izf) + whit_cmp_zfpar(cmp)
       else
          whit_zf(jzf) = whit_zf(jzf) + 1.
       endif
       domlay_zf(jzf) = dlnext
       z_zf(jzf) = fhitb_z(ih)
       cht_zf(jzf) = cht_zf(izf) + ch_zf(jzf)
       sign_zf(jzf) = xsig
       prev_zf(jzf) = izf
       fault_zf(jzf) = 0
       pfault_zf(jzf) = fault_zf(izf)
       dim_zf(jzf) = 1
       shadow_zf(jzf) = 0
       n_zf = n_zf + 1

       izfnew = jzf

*      **** fill candidate info
       if (nca_ft.ge.ncamx) then
        print *,' () tffilx: candidate overflow, nca_ft=', nca_ft
        go to 999
       endif
       nca_ft = nca_ft + 1
       jft = nca_ft
       first_ft(jft) = first_ft(ift)
       if (diag_level.ge.5) print *,' clone candidate, jft=', jft
       nhit_ft(jft)     = nhit_zf(jzf)
       last_ft(jft)     = jzf
       prev_ft(jft)     = prev_ft(ift)
       gen_ft(jft)      = gen_ft(ift) + 1
       nfault_ft(jft)   = nfault_ft(ift)
       quality_ft(jft)  = quality_ft(ift)
     +                    + 1.               ! bonus for new hit
     +                    - wchi_x_zfpar * ch_zf(jzf) ! malus for chi2

       alive_ft(jft)    = .true.
       mature_ft(jft)   = .false.
       stat_ft(jft) = stat_ft(ift)

#ifdef RGRAF
*      **** draw
       if (l_graf) then
*       **** draw markers
        call igset('LWID',1.)
        call ismk(2)
        wc(1) = xx_zf(1,izf)
        wc(2) = 0.
        wc(3) = z_zf(izf)
        call dipro(wc,xxx(1),yyy(1))
**      call ipm(1,xxx,yyy)
        wc(1) = xx_zf(1,jzf)
        wc(2) = 0.
        wc(3) = z_zf(jzf)
        call dipro(wc,xxx(2),yyy(2))
        call ipl(2,xxx,yyy)
**        call ipm(2,xxx,yyy)
        call iuwk(0,1)
       endif
#endif

 10   continue

 999  end



