*CMZ :  4.04/01 15/10/96  19.02.14  by  Rainer Mankel
*-- Author :    Rainer Mankel   15/10/96
*-- changed :   A.Spiridonov    20/02/98
      subroutine tftpara(ndim,x_in,z_in,z_out,x_out,f,istat)

*     **** parabolic expansion of magnet propagator in d_z
      implicit none
      double precision fT,Tx2,Ty2,Txy,Ax,Ay
     +    ,Tx,Ty,z_in,z_out,f(5,5),d_z,c,x_in(5),x_out(5)
      real H(3),X(3)
      integer ndim,istat

      integer if_last
      real H_last(3),X_last(3),Dx_max,Dy_max,Dz_max
      data Dx_max/0.2/,Dy_max/0.1/,Dz_max/0.1/
*      data Dx_max/2.0/,Dy_max/0.5/,Dz_max/0.5/
*      data Dx_max/5./,Dy_max/1./,Dz_max/1./
*      data Dx_max/5./,Dy_max/5./,Dz_max/5./
      data X_last/3*1.2345e10/

      X(1) = x_in(1)  
      X(2) = x_in(2)   
      X(3) = z_in    
     
      d_z = z_out - z_in
      c = 0.00029975d0          ! assume field in kG
      
      if_last = 0
      if(abs(X(3)-X_last(3)).lt.Dz_max) then
        if(abs(X(1)-X_last(1)).lt.Dx_max) then
          if(abs(X(2)-X_last(2)).lt.Dy_max) then
            H(1) = H_last(1)
            H(2) = H_last(2)
            H(3) = H_last(3)
            if_last = 1
          end if
        end if
      end if
      
      if(if_last.eq.0) then
        call utfeld(X,H)
        X_last(1) = X(1)
        X_last(2) = X(2)
        X_last(3) = X(3)
        H_last(1) = H(1)
        H_last(2) = H(2)
        H_last(3) = H(3)
      end if

      Tx = x_in(3)
      Ty = x_in(4)
      Tx2= Tx*Tx
      Ty2= Ty*Ty
      Txy= Tx*Ty
      fT = dsqrt( 1.d0 + Tx2 + Ty2 )

      Ax  = fT * ( Txy       *H(1) - (1.d0+Tx2) * H(2) + Ty*H(3) )
      Ay  = fT * ( (1.d0+Ty2)*H(1) - Txy        * H(2) - Tx*H(3) )

      x_out(1) = x_in(1) + Tx * d_z
     +     + 0.5 * Ax * x_in(5) * c * d_z**2
      x_out(2) = x_in(2) + Ty * d_z
     +     + 0.5 * Ay * x_in(5) * c * d_z**2
      x_out(3) = Tx + Ax * x_in(5) * c * d_z
      x_out(4) = Ty + Ay * x_in(5) * c * d_z
      x_out(5) = x_in(5)

      f(1,1) = 1.d0
      f(1,2) = 0.d0
      f(1,3) = d_z
      f(1,4) = 0.d0     
      f(1,5) =       0.5 * Ax * c * d_z**2

      f(2,1) = 0.d0
      f(2,2) = 1.d0
      f(2,3) = 0.d0
      f(2,4) = d_z 
      f(2,5) = 0.0      

      f(3,1) = 0.d0
      f(3,2) = 0.d0
      f(3,3) = 1.d0
      f(3,4) = 0.d0       
      f(3,5) =        Ax * c * d_z

      f(4,1) = 0.d0
      f(4,2) = 0.d0
      f(4,3) = 0.0
      f(4,4) = 1.d0  
      f(4,5) = 0.d0

      f(5,1) = 0.d0
      f(5,2) = 0.d0
      f(5,3) = 0.d0
      f(5,4) = 0.d0
      f(5,5) = 1.d0

      istat = 0

      end
