
// ********************************************************************
//
//  Routine:      rc99AParticleID
//  Author:       T.Oest/D.Samtleben
//
//  Description:  stand alone reconstruction
//
//  Modification:
//   --  RICH particle ID added                        14/09/99 T.Oest
//   --  bug correction (rc99AidRICH was never called) 16/04/00 T.Oest
//   --  introduce timers                              18/05/00 AG
//   -- creation of chrono jobs only once per job      24/05/00 D.Samtleben
//   -- initialize timers to 0                          7/06/00 AG
//   -- remove sepearte timers again                    7/06/00 AG
//
// ********************************************************************

// standard includes
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>

// ARTE includes
#include "reco/rc99Areco.hh"
#include "reco/rcflags.hh"
#include "farm/farm.hh"

// prototypes
int rc99AidRICH(int);
int rc99AidECAL();

//********************************************************************
// rcParticleID
//********************************************************************
  int rc99AParticleID() {

  int ECALidFlag = 0;
  int RICHidFlag = 0;

//===================================================================
//  RICH particle ID for electrons
//===================================================================

    if (recoPidRICH){
      ARTE_mark( "rc99AidRICH", 0 );
      RICHidFlag = rc99AidRICH(recoPidRICH) ;
    }

//===================================================================
//  ECAL particle ID for electrons & gammas
//===================================================================

    if (recoPidECAL){
      ARTE_mark( "rc99AidECAL", 0 );
      ECALidFlag = rc99AidECAL();
    }

//===================================================================
//  flag for particle ID
//===================================================================

    return 0;
  }

