*
*-- Author :    Vik   11/11/98
*
      SUBROUTINE TRD_WAY(N_MR,I,NN_BLOK)

**********************************************************************
*
* Description: extropolate "seed" to the next row.
*              If routine find at least one hit, create next candidates
*              for each hit. The "seed" loss if algoritm don't found
*              hits in 3 next layers. 
*
* Called from: TRD_REC
*
*
*          in: N_MR    - Matrix number
*              I       - Seed number for matrix N_MR
*              NN_BLOK - TRD blok
* 
*
*********************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "gean/gclink.fi"
#include "gean/gcvolu.fi"
#include "gean/gcflag.fi"
#include "gean/ZGMOTH.fi"
#include "auto/GEO.fi"
#include "gean/ZGESL.fi"
#include "gean/ZGDETV.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/TOPP.fi"
#include "auto/DIGB.fi"
#include "auto/HITB.fi"

      DOUBLE PRECISION A, B      
      REAL X_TRD_SEED, Y_TRD_SEED, Z_TRD_SEED,
     +     TNXZ_TRD_SEED, TNYZ_TRD_SEED, X_BL_LEFT, DEL_Z,
     +     Z_SEED, D_STRAW, Z_BL_ST, Z_COR, X_COR, X_SEED,
     +     TNXZ_COR, T_SEED, Y_BL_LT, Y_BL_RT, X_BL_RT, DEL_Z_R
      INTEGER isl, INDX, ROW, N_MAX, N_MR, I, N_ROW, N_BLOK, K,
     +        NB_TRD_SEED, N_MATR, N_STRAW, N_STR_HIT, N_HT, L,
     +        ROAD, FLAG, NN_BLOK, J, L_COR, N_CHECK, N_START,
     +        N_J, N_CON, N_TR, N_HIT_ROW, N_TRA, TRD_VIEW,
     +        TRD_HITB, TRACK, II

      COMMON /TRD_SD/ X_TRD_SEED, Y_TRD_SEED, Z_TRD_SEED, TNXZ_TRD_SEED,
     +                TNYZ_TRD_SEED, NB_TRD_SEED, N_MATR
      COMMON /TRD_ROAD/ ROAD, FLAG, N_STR_HIT, TRACK
      COMMON /TRD_LEFT/ X_BL_LEFT, Z_BL_ST, Y_BL_LT, Y_BL_RT, X_BL_RT
      COMMON /TRD_ALL/ TRD_VIEW, TRD_HITB

      PARAMETER (N_MAX = 1000)
      PARAMETER (N_TRA = 100)
      DIMENSION X_BL_LEFT(12,16), Z_BL_ST(12,16)
      DIMENSION Y_BL_LT(12,16), Y_BL_RT(12,16), X_BL_RT(12,16)
      DIMENSION X_TRD_SEED(N_MAX,15),Y_TRD_SEED(N_MAX,15)
      DIMENSION Z_TRD_SEED(N_MAX,15), NB_TRD_SEED(N_MAX,15)
      DIMENSION TNXZ_TRD_SEED(N_MAX,15), TNYZ_TRD_SEED(N_MAX,15)
      DIMENSION ROAD(N_MAX,15,16,N_TRA), N_STR_HIT(3)
      DIMENSION TRACK(N_MAX,15,N_TRA)
      DIMENSION FLAG(N_MAX,15,16), N_HIT_ROW(16), N_CHECK(N_TRA)
      DIMENSION X_COR(16,N_TRA),Z_COR(16,N_TRA),TNXZ_COR(16,N_TRA)
      DIMENSION X_SEED(N_TRA), Z_SEED(N_TRA), T_SEED(N_TRA)
      DIMENSION TRD_VIEW(12,16,78), TRD_HITB(12,16,78)
C
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/TOPP.ff"
#include "auto/DIGB.ff"
#include "auto/HITB.ff"
C
C TRD Event Analysis.
C
*      PRINT *,'START WAY analysis for TRD', N_MR, I, NN_BLOK
C
      CALL VZERO(X_BL_LEFT, 192)
      CALL VZERO(X_BL_RT, 192)
      CALL VZERO(Z_BL_ST, 192)
      CALL VZERO(Y_BL_LT, 192)
      CALL VZERO(Y_BL_RT, 192)
      CALL VZERO(X_COR, 1600)
      CALL VZERO(Z_COR, 1600)
      CALL VZERO(TNXZ_COR, 1600)
      CALL VZERO(N_HIT_ROW,16)
      CALL VZERO(X_SEED, 100)
      CALL VZERO(Z_SEED, 100)
      CALL VZERO(T_SEED, 100)
      CALL VZERO(N_CHECK,100)
C
      DEL_Z   = 2.3125
      D_STRAW = 0.61
*      N_CHECK = 0
C
         DO isl = 1, NGESL()
            IF(IGESL_CMP(isl).EQ.LGESL_TRD)   THEN
               INDX = PGESL_GEDE(isl)
               DO WHILE (INDX.NE.0)
                  ROW = MGESL_GEDE(INDX)
                  INDX = XGESL_GEDE(INDX)
C
                  X_BL_LEFT(IGEDE_SEC(ROW),IGEDE_LAY(ROW)) = 
     +                                          FGEDE_XMIN(ROW)
                  X_BL_RT(IGEDE_SEC(ROW),IGEDE_LAY(ROW)) = 
     +                                          FGEDE_XMAX(ROW)
                  Z_BL_ST(IGEDE_SEC(ROW),IGEDE_LAY(ROW)) = 
     +                                          FGEDE_ZFW(1,ROW)
                  Y_BL_LT(IGEDE_SEC(ROW),IGEDE_LAY(ROW)) = 
     +                                          FGEDE_YMIN(ROW) 
                  Y_BL_RT(IGEDE_SEC(ROW),IGEDE_LAY(ROW)) = 
     +                                          FGEDE_YMAX(ROW) 
               END DO
            END IF
         END DO
C
         N_ROW = 5
         N_CON = 0
         N_TR  = 0
C
 20      CONTINUE
C
         IF(N_ROW.EQ.5) THEN
            N_START = 1
         ELSE
            N_START = N_HIT_ROW(N_ROW-1)
         END IF
C
         N_TR = N_START
C
         IF(NB_TRD_SEED(N_MR,I).EQ.NN_BLOK) THEN
C
            DO J = 1, N_START
C
	     N_J    = J
             N_BLOK = NN_BLOK
C
             IF(N_ROW.EQ.5) THEN
               Z_SEED(J)  = Z_TRD_SEED(N_MR,I)
               X_SEED(J)  = X_TRD_SEED(N_MR,I) + DEL_Z*
     +                         TNXZ_TRD_SEED(N_MR,I)
               T_SEED(J)  = TNXZ_TRD_SEED(N_MR,I)
             ELSE
*                Z_SEED(J) = Z_BL_ST(N_BLOK,N_ROW) + 
*     +                      D_STRAW/2
                Z_SEED(J) = Z_BL_ST(N_BLOK,N_ROW)
                DEL_Z_R   = Z_BL_ST(N_BLOK,N_ROW) - 
     +                      Z_BL_ST(N_BLOK,N_ROW-1)
                X_SEED(J) = X_COR(N_ROW-1,J) +
     +                      DEL_Z_R*TNXZ_COR(N_ROW-1,J)
                T_SEED(J) = TNXZ_COR(N_ROW-1,J)
             END IF
C
         N_STRAW = INT((X_SEED(J) - X_BL_LEFT(N_BLOK,N_ROW))
     +                          /D_STRAW)  + 1
C
               IF(N_STRAW.LT.1.OR.N_STRAW.GT.78) N_STRAW = 0
C
               CALL TRD_WIN(N_BLOK,N_ROW,N_STRAW,N_HT)
C
                   IF(N_HT.NE.0) THEN
                      N_CHECK(J) = 0
                   ELSE
                      N_CHECK(J) = N_CHECK(J) + 1
*                     IF(N_CHECK(J).EQ.3) NB_TRD_SEED(N_MR,I) = 0
                     IF(N_CHECK(J).EQ.3) TRACK(N_MR,I,J) = 0
                      X_COR(N_ROW,N_J)     = X_SEED(J)
                      Z_COR(N_ROW,N_J)     = Z_SEED(J)
                      TNXZ_COR(N_ROW,N_J)  = T_SEED(J)
                      GO TO 50
                   END IF
C
               DO K = 1, N_HT
C
                  N_CON = N_CON + 1
C
	          IF(K.GE.2) THEN
	            N_TR = N_TR + 1
	           DO L = 1, N_ROW - 1
	            N_J  = N_TR
	            ROAD(N_MR,I,L,N_J) = ROAD(N_MR,I,L,J)
	            FLAG(N_MR,I,L)     = N_J
                    TRACK(N_MR,I,N_J)  = N_J
	           END DO
	          END IF
C
                  ROAD(N_MR,I,N_ROW,N_J)    = N_STR_HIT(K)
                  FLAG(N_MR,I,N_ROW)        = N_J
                  TRACK(N_MR,I,N_J)         = N_J
C
                  CALL TRD_CORR(N_MR,I,N_BLOK,N_ROW,N_J,A,B)
C
                  Z_COR(N_ROW,N_J)      = Z_SEED(J)
                  X_COR(N_ROW,N_J)      = A*Z_COR(N_ROW,N_J) + B
                  TNXZ_COR(N_ROW,N_J)   = A
C
               END DO
C
 50            CONTINUE
C
             END DO
C
         END IF
C
         IF(N_TR.GE.N_TRA) THEN
            DO II = 1, N_TRA
               TRACK(N_MR,I,II) = 0
            END DO
            GO TO 900
         END IF
C
         N_HIT_ROW(N_ROW)    = N_TR
C
         N_ROW = N_ROW + 1
         N_CON = 0
         IF(N_ROW.LE.16) GO TO 20
C
*      PRINT *,'STOP WAY analysis for TRD'
C
 900  END

*********************************************************************
* End of TRD_WAY
************************************************************************
